% Andrew Gwozdziewycz CIS601-Fall04

function EQ=histoeq(imagein)
% histoeq(imagein) - Histogram equalize an image
%    imagein is the image to be equalized

  histo = histogram(imagein); % compute the histogram.
  % compute number of pixels (could also use numel)
  totalpixels = size(imagein, 1) * size(imagein, 2);
  
  %setup n blank for populating
  n = zeros(1,256); 
  
  %we need a j-1 so we need first element done first
  n(1) = histo(1) / totalpixels;
  
  % sum up probabilities... 
  for j = 2: 1: size(n,2);
      n(j) = (histo(j) / totalpixels) + n(j-1);
  end
  
  % apply new values based on the old values
  for y = 1: 1: size(imagein, 2);
      for x = 1: 1: size(imagein, 1);
          val = imagein(x, y);
          imageout(x, y) = n(val+1);
      end
  end
  % return it
  EQ = imageout;
  
